Page MenuHomePhabricator

machine-instruction combiner uses too-simple algorithm to compute cost of one of the two alternatives, throws away combination results too often
ClosedPublic

Authored by Abe on Dec 7 2016, 3:35 PM.

Details

Summary

We have found that -- when the selected subarchitecture has a scheduling model and we are not optimizing for size -- the machine-instruction combiner uses a too-simple algorithm to compute the cost of one of the two alternatives [before and after running a combining pass on a section of code], and therefor it throws away the combination results too often.

This fix has the potential to help any ISA with the potential to combine instructions and for which at least one subarchitecture has a scheduling model.

As of now, this is only known to definitely affect AArch64 subarchitectures with a scheduling model.

Patch by Abe Skolnik and Sebastian Pop.

Regression tested on AMD64/GNU-Linux, new test case tested to fail on an unpatched compiler and pass on a patched compiler.

Diff Detail

Event Timeline

Abe updated this revision to Diff 80676.Dec 7 2016, 3:35 PM
Abe retitled this revision from to machine-instruction combiner uses too-simple algorithm to compute cost of one of the two alternatives, throws away combination results too often.
Abe updated this object.
Abe added reviewers: Gerolf, spatel.
Abe set the repository for this revision to rL LLVM.
Abe added a subscriber: sebpop.
Abe updated this object.Dec 7 2016, 3:38 PM
Gerolf edited edge metadata.EditedDec 8 2016, 3:05 PM

Good catch. LGTM.

evandro added a subscriber: evandro.Dec 8 2016, 3:10 PM
sebpop accepted this revision.Dec 11 2016, 11:51 AM
sebpop added a reviewer: sebpop.

Committed as r289399.

This revision is now accepted and ready to land.Dec 11 2016, 11:51 AM
sebpop closed this revision.Dec 11 2016, 11:52 AM